package org.elsysbg.courses.ip.jsf.examples.converter;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

import org.elsysbg.courses.ip.jsf.examples.model.Color;

import com.sun.faces.util.MessageFactory;

public class ColorConverter implements Converter {

	public Object getAsObject(FacesContext context, UIComponent component, String value) {
		if(value==null) {
			return null;
		}
		final Color result;
		if(value.equals("red")) {
			result = new Color(255, 0, 0);
		} else if(value.equals("green")) {
			result = new Color(0, 255, 0);
		} else if(value.equals("blue")) {
			result = new Color(0, 0, 255);
		} else if(value.equals("white")) {
			result = new Color(255, 255, 255);
		} else if(value.equals("black")) {
			result = new Color(0, 0, 0);
		} else {
			final FacesMessage facesMessage = MessageFactory.getMessage("conver_error_color", value);
			facesMessage.setSeverity(FacesMessage.SEVERITY_ERROR);

			System.err.println(facesMessage.getDetail());
			throw new ConverterException(facesMessage);
		}
		System.out.println(String.format("Color %s converted to: %s", value, result));
		return result;
	}

	public String getAsString(FacesContext context, UIComponent component, Object value) {
		if (value instanceof Color) {
			final Color color = (Color) value;
			
			return color.getName();
		}
		final String message = "This is not color: "+value;
		System.err.println("This is not color: "+value);
		throw new ConverterException(message);
	}

}
